<template>
  <main class="flex justify-center items-center bg-gray-200 text-gray-600 px-4">
    <div class="flex flex-col lg:flex-row items-start justify-center gap-8 my-8">
      <LeftTable
        :employees="this.employees"
        @clickedRow="(officeCode) => this.getOffice(officeCode)"
        @openCreate="this.createEditOpen = true"
        @openEdit="(employeeNumber) => openEdit(employeeNumber)"
        @openDelete="(employeeNumber) => openDelete(employeeNumber)"
      />
      <RightTable :office="this.office" />
      <CreateEditEmployeeModal
        :isModalVisible="createEditOpen"
        :employees="this.employees"
        @closeCreateEdit="this.createOpen = false"
        @employeeCreatedEdited="getEmployees"
      />
      <CreateEditEmployeeModal
        :employeeData="this.employeeData"
        :employees="this.employees"
        :isModalVisible="createEditOpen"
        :currentEmployee="this.currentEmployee"
        @closeCreateEdit="this.createEditOpen = false"
        @employeeCreatedEdited="getEmployees"
        @clearEmployeeData="clearEmployeeData"
      />
      <DeleteEmployeeModal
        :isModalVisible="deleteOpen"
        :employee="this.currentEmployee"
        @closeDelete="this.deleteOpen = false"
        @employeeDeleted="employeeDeleted"
      />
    </div>
  </main>
</template>

<script>
import CreateEditEmployeeModal from './components/CreateEditEmployeeModal.vue'
import DeleteEmployeeModal from './components/DeleteEmployeeModal.vue'
import LeftTable from './components/LeftTable.vue'
import RightTable from './components/RightTable.vue'

export default {
  components: {
    LeftTable,
    RightTable,
    CreateEditEmployeeModal,
    DeleteEmployeeModal
  },
  data() {
    return {
      employees: [],
      office: {},
      createEditOpen: false,
      deleteOpen: false,
      currentEmployee: null,
      employeeData: null
    }
  },
  methods: {
    getOffice(officeCode) {
      fetch(`http://localhost:5000/office/${officeCode}`)
        .then((response) => response.json())
        .then((data) => {
          this.office = data.data[0]
        })
    },
    openEdit(employeeNumber) {
      this.createEditOpen = true
      this.employeeData = this.employees.filter((item) => item.employeeNumber == employeeNumber)[0]
      this.currentEmployee = this.employeeData.employeeNumber
    },
    openDelete(employeeNumber) {
      this.deleteOpen = true
      this.currentEmployee = employeeNumber
    },
    employeeDeleted() {
      this.currentEmployee = null
      this.getEmployees()
    },
    getEmployees() {
      fetch('http://localhost:5000/employees')
        .then((response) => response.json())
        .then((data) => {
          this.employees = data.data
        })
    },
    clearEmployeeData() {
      this.employeeData = null
    }
  },
  created() {
    this.getEmployees()
  }
}
</script>
